Attribute VB_Name = "modMain"
' Each trial is fixed at 1.125 TRs long
' At start of trial, a pulse isn't necessarily heard by SynchroniseExperiment False...
' However, also listen for them during trial (CheckPulseSynchrony command)

Dim objSS As New ScannerSync

Const USEPRETENDMODE = True ' Change to false if on mimic or real machine
Const TR = 2000 ' 2000 ms = 2 s
Const NUMDUMMIES = 5
Const NUMTRIALS = 10
Const TRIALLENGTH = 1.125 ' = 1 1/8 of a TR, so will sample 8 points in TR

Sub Main()
Dim dblTrialStartTime As Double
Dim intPulseNum As Integer

If (USEPRETENDMODE) Then
    objSS.SetPretendMode True
Else
    objSS.Initialize ("") ' Will only run if on a machine with appropriate IO card
End If


Debug.Print "Waiting for first pulse"

' Wait for first pulse
objSS.StartExperiment TR

Debug.Print "Beginning experiment at " & Now()

For i = 1 To NUMDUMMIES - 1   '-1 as first trial will also wait for its alloted time
    objSS.SynchroniseExperiment True, 0
    Debug.Print "Found dummy " & i & " at " & objSS.SSGetTimer
Next

dblTrialStartTime = 5

For i = 1 To NUMTRIALS
    
    intPulseNum = Int(dblTrialStartTime)
    
    'First trial begins at time 5, next 6.125, next 7.25, and so on
    ' Don't actually wait for a pulse here, as "False" is first parameter
    ' But, synchronise to time with appropriate delay (calculated in ms)
    
    objSS.SynchroniseExperimentToPulseNumber False, intPulseNum, (dblTrialStartTime - intPulseNum) * objSS.GetMeasuredTR
        
    Debug.Print "Trial " & i & " start time is " & objSS.SSGetTimer
    ' This is where your trial code would go... instead do a thing that takes a while
    q = 0#
    For j = 1 To 500
        q = Sin(j) ' a random thing to take some time
       ' Listen out for pulses when we can...
        objSS.CheckPulseSynchronyForTime 1
    Next
    
    Debug.Print "Current measured TR is " & objSS.GetMeasuredTR
    
    dblTrialStartTime = dblTrialStartTime + TRIALLENGTH
Next

End Sub
